// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: Array
// Author: Hassan Siddiqui
//
// Description: 
//
// Class representation of a PixelIterator that handles arrays
//
// Modifications: See ChangeLog
// 
// $Id: ArrayPixelIterator.h,v 1.3 2000/10/06 15:24:56 hsiddiqu Exp $

#ifndef ARRAYPIXELITERATOR_H
#define ARRAYPIXELITERATOR_H

// General classes
#include <iostream>

// SAS-specific classes
#include "Dal.h"
#include "ConvertableData.h"
#include "errstr.h"
#include "Tracer.h"

// Local classes
#include "PixelIterator.h"
#include "WCSConvertor.h"
#include "PixelElement.h"

class ArrayPixelIterator : public PixelIterator
{
public:

  /* Constructors */
  ArrayPixelIterator(const string & arrayname);

  /* Destructors */
  ~ArrayPixelIterator();

  /* Iterator methods */
  void first();
  void next ();
  bool isDone();
  PixelElement currentItem();

  /* WCSConvertor object */
  const WCSConvertor * wcsconvertor() const;
  
  /* The total number of elements in map */
  unsigned size() const;

  /* The number of bins in x-direction 
     (not a generic PixelIterator method) */
  unsigned xbins() const;

private:

  /* Disallow default constructor */
  ArrayPixelIterator();

  bool _firstcalled;
  unsigned long _index;
  unsigned long _xindex;
  unsigned long _yindex;
  unsigned long _xbins;
  unsigned long _size;

  DataSet *      _set;
  Array *        _array;
  ArrayData *    _arraydata;
  ConvertableData _arrayvalue;
  WCSConvertor * _wcsconv;

};

#endif
