// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: NullPixelIterator
// Author: Hassan Siddiqui
//
// Description: 
//
// Class that does not iterate through a pixel structure as such; it only
// iterates once and returns a single PixelElement object.
// Used in cases where an iterator is required, 
// but no real Detmap is specified.
//
// Modifications: See ChangeLog
// 
// $Id: NullPixelIterator.h,v 1.3 2000/10/06 15:24:56 hsiddiqu Exp $

#ifndef NULLPIXELITERATOR_H
#define NULLPIXELITERATOR_H

// General classes
#include <iostream>

// SAS-specific classes
#include "Dal.h"

// General utility functions
#include "errstr.h"
#include "Tracer.h"

// Local classes
#include "PixelIterator.h"
#include "WCSConvertor.h"
#include "PixelElement.h"

class NullPixelIterator : public PixelIterator
{
public:

  /* Constructors */
  NullPixelIterator();

  /* Destructors */
  ~NullPixelIterator();

  /* Iterator methods */
  void   first();
  void    next ();
  bool   isDone();
  PixelElement currentItem();

  /* Size methods */
  unsigned    size()  const;
  unsigned    xbins() const;

  /* WCSConvertor object */
  const WCSConvertor * wcsconvertor() const;

private:
  bool _firstcalled;
  bool _isdone;
  WCSConvertor * _wcsconv;

};

#endif
