// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: PixelIterator
// Author: Hassan Siddiqui
//
// Description: 
//
// Allows one to iterate across a structure of pixels.
// Useful for traversing detector maps
// as described in email XMM-SOC/HS/1999-100,
// or detector masks.
//
// Modifications: See ChangeLog
// 
// $Id: PixelIterator.h,v 1.5 2001/03/20 17:12:05 hsiddiqu Exp $

#ifndef PIXELITERATOR_H
#define PIXELITERATOR_H

// General classes

// SAS-specific classes

// General utility functions

// Local classes
#include "GeneralIterator.h"
#include "PixelElement.h"
#include "WCSConvertor.h"

class PixelIterator : public GeneralIterator<PixelElement>
{
public:

  /* Constructor */
  PixelIterator();

  /* Destructor */
  virtual ~PixelIterator();

  /* The total number of elements in map */
  virtual unsigned size() const = 0;
  virtual unsigned xbins() const = 0;

  /* The bounds of map in physical coordinates */
  /* [HS] new methods as a result of new WCSConvertor i/f -
    X and Y positions now treated as a related pair */
  CoordPair physXYmin() const  ;
  CoordPair physXYmax() const  ;

  /* WCSConvertor object */
  virtual const WCSConvertor * wcsconvertor() const = 0;

  /* Get the normalised pixel value */
  PixelElement normalisedItem();

  void normalise();

  bool hasValidNormalisation();

private:

  double _isNormalised;
  double _normalisation;
  bool   _hasValidNormalisation;
};

#endif
